"""
 * Copyright (C) 2013   Christian Eppler
 * File:                src/file.py
 * Project              addrs
 * Title:               Convert addr to different formats
 * Author:              Christian Eppler
 * E-Mail:              weblooker@silentchris.de
 * Created on:          16.03.2013
 *
 * This program is free software; you can redistribute it and/or modify it under the terms of
 * the GNU General Public License as published by the Free Software Foundation; either version 3
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along with this program;
 * if not, see <http://www.gnu.org/licenses/>.
"""

class Convertaddr:
    
    def __init__(self,addr):
        self.hex = ""
        self.bin = ""
        self.dec = ""
        self.addr = 0
        self.setaddr(addr)
        
        
    def setaddr(self, addr):
        try:
            self.addr = int(addr)
        except (ValueError):
            print("Addr was no Number")
            self.addr = None
            return
        
        self.dectohex()
        self.dectobin()
        self.dectodec()
   
    
    def dectohex(self):
        result = self.addr
        leftover = self.addr
        erg = []
        
        while result > 0:
            leftover = result & 15
            result >>= 4
            erg.append(chr(leftover +(48 if leftover < 10 else 55)))

        erg.reverse()

        self.hex  = "0x"
        self.hex += "".join(erg)
        
    def dectobin(self):
        result = self.addr
        leftover = self.addr
        erg = []
        
        while result > 0:
            leftover = result & 1
            result >>= 1
            erg.append(chr(leftover +48))

        erg.reverse()

        self.bin= "".join(erg)
        
    def dectodec(self):
        self.dec = str(self.addr)
        
    def gethex(self):
        return self.hex
    def getbin(self):
        return self.bin
    def getdec(self):
        return self.dec