"""
 * Copyright (C) 2013   Christian Eppler
 * File:                src/parseinput.py
 * Project              addrs
 * Title:               Parse input from console
 * Author:              Christian Eppler
 * E-Mail:              weblooker@silentchris.de
 * Created on:          16.03.2013
 *
 * This program is free software; you can redistribute it and/or modify it under the terms of
 * the GNU General Public License as published by the Free Software Foundation; either version 3
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along with this program;
 * if not, see <http://www.gnu.org/licenses/>.
"""

import argparse
import sys

def address(string):  
    try:
        value = int(string)
    except (ValueError):
        try:
            value = int(string,16)
        except (ValueError):
            msg = "%r is not a correct address" % string
            raise argparse.ArgumentTypeError(msg)
    return value



parser = argparse.ArgumentParser(description='Search for address on files.')

parser.add_argument('-b','--binary', action='store_true', help='Given address is binary')
parser.add_argument('-all','--all', action='store_true', help='Search in hidden folders and files too')
#parser.add_argument('-c','--calculate', action='store_true', help='Static calculations are calculated. (slow)')
parser.add_argument('-addr','--address', type=address,
                   help='Address to search (Hex or decimal)', default=123456)
parser.add_argument('-p','--path', help='File or path to search')

        
args = parser.parse_args()

if(len(sys.argv) <= 1):
    parser.print_help()
    sys.exit()

if(args.path is None):
    args.path = "./"
    
if(args.binary is True):  
    try:
        args.address = int(str(args.address),2)
    except (ValueError):       
        msg = "%r is not a correct address" % args.address
        print(msg)
        sys.exit()
    
