"""
 * Copyright (C) 2013   Christian Eppler
 * File:                src/readfile.py
 * Project              addrs
 * Title:               Read files from path
 * Author:              Christian Eppler
 * E-Mail:              weblooker@silentchris.de
 * Created on:          16.03.2013
 *
 * This program is free software; you can redistribute it and/or modify it under the terms of
 * the GNU General Public License as published by the Free Software Foundation; either version 3
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along with this program;
 * if not, see <http://www.gnu.org/licenses/>.
"""

import os

class Readfiles:
    def __init__(self, rootdir, all):
        self.files = []
        self.count = -1
        self.len = 0

        for root, subFolders, files in os.walk(rootdir):
            for i in files:
                if(all is False and( i[0] == '.' or root.count("."))):
                    continue
                    
                self.files.append(root.rstrip("/")+"/"+i)
        
        if(len(self.files) == 0 and os.path.isfile(rootdir)):
            self.files.append(rootdir)
    
        self.len = len(self.files)
    
    def nextfile(self):
        if self.count == self.len-1:
            return None
        
        self.count += 1
        return 1
        
    def getfile(self):
        return self.files[self.count]

        